package com.logicbig.example;

import com.rometools.rome.feed.atom.Content;
import com.rometools.rome.feed.atom.Entry;
import com.rometools.rome.feed.atom.Feed;
import com.rometools.rome.feed.atom.Link;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.view.feed.AbstractAtomFeedView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

@Component("atomFeedView")
public class MyAtomFeedView extends AbstractAtomFeedView {

    @Override
    protected void buildFeedMetadata(Map<String, Object> model, Feed feed,
                                     HttpServletRequest request) {

        FeedInfo feedInfo = (FeedInfo) model.get("feedInfo");
        feed.setTitle(feedInfo.getTitle());
    }


    @Override
    protected List<Entry> buildFeedEntries(Map<String, Object> model,
                                           HttpServletRequest request,
                                           HttpServletResponse response) throws Exception {
        List<Entry> entries = new ArrayList<>();
        FeedInfo feedInfo = (FeedInfo) model.get("feedInfo");
        for (FeedEntry fe : feedInfo.getFeedEntries()) {
            Entry entry = new Entry();
            entry.setTitle(fe.getTitle());

            Link link = new Link();
            link.setHref(fe.getLink());
            entry.setAlternateLinks(Arrays.asList(link));

            entry.setPublished(fe.getDate());

            Content content = new Content();
            content.setValue(fe.getContent());
            entry.setSummary(content);
            entries.add(entry);
        }

        return entries;
    }
}